
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Objective-C Runtime机制详解 / 憋错料</title>

    <meta name="description" content="Objective-C Runtime机制详解 Objective-C语言是一门动态语言,它将很多静态语言在编译和链接时做的事放到了运行时来处理.同时OC也是一门简单的语言,很大一部分是C的内容,只是在语言层面上加了关键字和语法,真正让OC强大的是它的运行时,它很小却很强大,其中核心是消息分发.这种动态语言的优势在于:我们写代码时更加灵活,如我们可以把消息转发给我们想要的对象,或者随意交换一个方法的实现. 这种特性意味着OC不仅需要一个编译器,还需要一个运行时系统来执行编译的代码.对于OC来说,这个运行时系统就像一个操作系统一样.这个运行时系">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Objective-C Runtime机制详解</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>Objective-C语言是一门动态语言，它将很多静态语言在编译和链接时做的事放到了运行时来处理。同时OC也是一门简单的语言，很大一部分是C的内容，只是在语言层面上加了关键字和语法，真正让OC强大的是它的运行时，它很小却很强大，其中核心是消息分发。这种动态语言的优势在于：我们写代码时更加灵活，如我们可以把消息转发给我们想要的对象，或者随意交换一个方法的实现。</p>
<p>这种特性意味着OC不仅需要一个编译器，还需要一个运行时系统来执行编译的代码。对于OC来说，这个运行时系统就像一个操作系统一样。这个运行时系统即Runtime，是用C和汇编写的，这个库使得C语言有了面向对象的能力。其中最主要的是消息机制。对于C语言，函数的调用在编译的会决定调用哪个函数，编译完成之后顺序执行，无任何二义性。OC的函数调用称为消息发送，属于动态调用过程。在编译的时候并不能决定真正的调用哪个函数（事实证明，在编译阶段，OC可以调用任何函数，即使这个函数并未实现，只要声明过就不会报错。而C语言在编译阶段就会报错。）只有在真正运行的时候才会根据函数的名称找到对应的函数来调用。</p>
<p>用一句话说：我们编写的OC代码，程序运行过程中，其实都是转化为runtime的C语言代码，runtime算是OC幕后工作者。runtime属于OC的底层，可以进行非常底层的操作（用OC是无法实现的。）</p>
<p>Runtime库主要做下面几件事：</p>
<p>1.封装：在这个库中，对象可以用C语言中的结构体表示，而方法可以用C函数来实现，另外再加上一些额外的特性。这些结构体和函数被Runtime函数封装后，我们就可以在程序运行时创建、检查、修改类、对象和他们的方法了。</p>
<p>2.找出方法的最终执行代码：当程序执行[object doSomething]时，会向消息接收者(object)发送一条消息(doSomething)，Runtime会根据消息接收者是否能响应该消息而做出不同的反应。</p>
<p>OC的Runtime目前有两个版本：Modern Runtime和Legacy runtime.&nbsp; Modern Runtime主要用于64位应用。Legacy runtime主要用于32位应用。目前一般都是64位了。</p>
<p>关于执行效率问题，“静态语言执行效率要比动态语言高”应该是没问题的。因为一部分的CPU计算损耗在Runtime中。</p>
<p>那OC是怎么实现动态调用的呢？假如在OC中写了如下代码：</p>
<pre>[obj makeText];</pre>
<p>其中obj是一个对象，makeText是一个函数名称。执行一个方法，有些语言，编译器会执行一些额外的优化和错误检查，因为调用关系很直接也很明显。但是对于消息分发来说，就不那么明显了，在发消息之前不必知道某个对象是否能够处理消息。你把消息发给他，他可能会处理，也可能转给其他的Object来处理。一个消息不必对应一个方法，一个对象可能实现一个方法来处理多条消息。</p>
<p>在编译时RunTime会将上述代码转化为：</p>
<pre>objc_msgSend(obj,@selector(makeText));
</pre>
<p>所以其实</p>
<pre>objc_msgSend(obj,@selector(makeText));
和
&lt;pre name=&quot;code&quot; class=&quot;plain&quot;&gt;[obj makeText];</pre>
<p>是等价的。</p>
<p>再比如：</p>
<p>[obj setTT:@&quot;111&quot; isOK:YES];</p>
<p>和</p>
<p>objc_msgSend(obj,@selector(setTT:isOK:),@&quot;111&quot;,YES)</p>
<p>也是等价的。注意有参数的OC函数名的表达方式。</p>
<pre></pre>
<p>首先我们来看看obj这个对象，iOS中的obj都继承与NSObject。</p>
<pre>@interface NSObject{

 Class isa OBJC_ISA_AVAILABILITY

}</pre>
<p>在NSObject中存在一个Class的isa指针。然后我们看看Class是什么东西：这是在objc.h中定义的。</p>
<pre>typedef struct objc_class *Class;
struct objc_class{

 Class isa; //指向metaclass

 Class super_class ;//指向父类

 const char *name;//类名

 long version;  //类的版本信息，初始化默认为0，可以通过runtime函数class_setVersion和class_getVersion进行修改读取；

 long info;   //一些标识信息，如CLS_CLASS(0x1L)表示该类为普通的class，其中包含对象方法和成员变量；CLS_META(0x2L)表示该类为metaclass,其中包含类方法；

 long instance_size;  该类的实例变量大小(包括从父类继承下来的实例变量);

 struct objc_ivar_list *ivars;  //用于存储每个成员变量的地址；

 struct objc_method_list **methodLists;   //与info的一些标志位有关，如CLS_CLASS(0x1L),则存储对象方法；

 struct objc_cache *cache;  //指向最近使用的方法的指针，用于提升效率；

 struct objc_protocol_list *protocols;  //存储该类遵守的协议;
}</pre>
<p>对于一个Class类中，存在很多东西，我们来解释一下重要的东西：</p>
<p>Class isa ：指向metaclass ,也就是静态的Class。一般一个Obj对象中的isa会指向普通的Class，这个Class中存储普通成员变量和对象方法（-开头的方法），普通Class中的isa指针指向静态Class，静态Class中存储static类型成员变量和类方法（&#043;开头的方法）。</p>
<p>Class super_class:指向父类，如果这个类是根类，则为NULL。</p>
<p>我们通过下面这个图来了解类和对象的继承关系：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTEwMjcyMTU3MjE5OTA/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg">。</p>
<p>注意：所有metaclass中isa指针都指向根metaclass（也就是Root Class Meta），而根metaclass则指向自身。Root metaclass是通过继承Root Class产生的。与root class结构成员一致，也就是前面提到的结构。不同的是Root metaclass的isa指针指向自身。</p>
<p>然后再来看看方法：</p>
<p>@selector(makeText):这是一个SEL方法选择器。SEL的主要作用就是通过方法名字(makeText)查找到对应方法的函数指针，然后调用其函数。SEL其本身是一个int类型的一个地址，地址中存放着方法的名字。对于一个类中，每一个方法对应着一个SEL。所以iOS类中不能存在2个名称相同的方法，即使参数类型不同，因为SEL是根据方法名字生成的，相同的方法名称只能对应一个SEL。同时，我们也应该知道，OC是没有方法重载的。</p>
<p>我们再来看看具体的消息发送之后是怎么样来动态查找对应的方法的。</p>
<p>首先，编译器将代码[obj makeText]；转化为objc_msgSend(obj,@selector(makeText));在objc_msgSend函数中，首先通过obj的isa指针找到对应的class。在Class中先去cache中通过SEL查找对应函数method，若cache中未找到，再去methodList中查找，若methodList中未找到，则取superClass中查找。若能找到，则将method加入到cache中，以方便下次查找，并通过method中的函数指针跳转到对应的函数中去执行。</p>
<p>class的方法列表其实是一个字典，key为selector，value为IMP函数指针。一个IMP是指向方法在内存中的实现。很重要的一点，selector和IMP之间的关系是在运行时才决定的，而不是编译时。</p>
<p>对于面向对象而言，万物皆对象，在OC中，类也是对象。The class is Object，也可以处理消息。所以你现在知道为什么会有类方法和实例方法了。</p>
<p>Method Swizzling</p>
<p>我们上面讲过，方法由两个部分组成。selector相当于一个方法的id，IMP是方法的实现。这样分开的一个遍历就是selector和IMP之间的对应关系可以被改变。比如一个IMP可以有多个selectors指向它。</p>
<p>而Method Swizzling可以交换两个方法的实现。在OC中，两种扩展class的途径。首先是subclass.你可以重写某个方法，调用父类的实现，这也意味着你必须使用这个subclass的实例。但是我们如果使用Category分类，重写某个方法之后，就不能再调用原来的方法了。</p>
<p>Method Swizzling可以搞定这个问题，你可以重写某个方法而不用继承，同时还可以调用原先的实现。通常的做法是在Category中添加一个方法，可以通过method_exchangeImplementations这个运行时方法来交换实现。</p>
<p>版权声明：本文为博主原创文章，未经博主允许不得转载。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 19:30:03 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/ios/" title="ios">ios</a>, <a href="https://www.biecuoliao.com/tag/runtime/" title="runtime">runtime</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Objective-C Runtime机制详解的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0a6rkn3.html" rel="bookmark">AsyncTask机制详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				AsyncTask是Android提供的一个轻量级异步任务机制,使用AsyncTask可以方便的执行异步任务,并将结果更新到main thread.AsyncTask中是通过Handler机制来让work thread和main thread通信的.如果你对Handler还不了解的话,可以通过我的这篇博客来了解Android的Handler机制.Android 异步消息处理机制 在这篇文章中我们将了解AsyncTask的基本用法以及从源码的角度来分析AsyncTask机制,首先我们来了解下开发过			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47YWA60.html" rel="bookmark">Android应用AsyncTask处理机制详解及源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[工匠若水 http://blog.csdn.net/yanbober 转载烦请注明出处,尊重分享成果] 1 背景 Android异步处理机制一直都是Android的一个核心,也是应用工程师面试的一个知识点.前面我们分析了Handler异步机制原理(不了解的可以阅读我的&lt;Android异步消息处理机制详解及源码分析&gt;文章),这里继续分析Android的另一个异步机制AsyncTask的原理. 当使用线程和Handler组合实现异步处理时,当每次执行耗时操作都创建一条新线程进行处理,性能开销会比			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/L3rkml4.html" rel="bookmark">Android触摸屏事件派发机制详解与源码分析二&lpar;ViewGroup篇&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 背景 还记得前一篇&lt;Android触摸屏事件派发机制详解与源码分析一(View篇)&gt;中关于透过源码继续进阶实例验证模块中存在的点击Button却触发了LinearLayout的事件疑惑吗?当时说了,在那一篇咱们只讨论View的触摸事件派发机制,这个疑惑留在了这一篇解释,也就是ViewGroup的事件派发机制. PS:阅读本篇前建议先查看前一篇&lt;Android触摸屏事件派发机制详解与源码分析一(View篇)&gt;,这一篇承接上一篇. 关于View与ViewGroup的区别在前一篇的A			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49ZPavM.html" rel="bookmark">【Hibernate步步为营】--锁机制详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上篇文章详细讨论了hql的各种查询方法,在讨论过程中写了代码示例,hql的查询方法类似于sql,查询的方法比较简单,有sql基础的开发人员在使用hql时就会变得相当的简单.Hibernate在操作数据库的同时也提供了对数据库操作的限制方法,这种方法被称为锁机制,Hibernate提供的锁分为两种一种是乐观锁,另外一种是悲观锁.通过使用锁能够控制数据库的并发性操作,限制用户对数据库的并发性的操作. 一.锁简介 锁能控制数据库的并发操作,通过使用锁来控制数据库的并发操作,Hibernate提供了两种			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mz88dd3.html" rel="bookmark">浏览器缓存机制详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				对于浏览器缓存,相信很多开发者对它真的是又爱又恨.一方面极大地提升了用户体验,而另一方面有时会因为读取了缓存而展示了&quot;错误&quot;的东西,而在开发过程中千方百计地想把缓存禁掉.那么浏览器缓存究竟是个什么样的神奇玩意呢? 什么是浏览器缓存: 简单来说,浏览器缓存就是把一个已经请求过的Web资源(如html页面,图片,js,数据等)拷贝一份副本储存在浏览器中.缓存会根据进来的请求保存输出内容的副本.当下一个请求来到的时候,如果是相同的URL,缓存会根据缓存机制决定是直接使用副本响应访问请求,还是			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3r2m1w3.html" rel="bookmark">Android触摸屏事件派发机制详解与源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				请看下面三篇博客,思路还是蛮清晰的,不过还是没写自定义控件系列哥们的思路清晰: Android触摸屏事件派发机制详解与源码分析一(View篇) http://blog.csdn.net/yanbober/article/details/45887547 Android触摸屏事件派发机制详解与源码分析二(ViewGroup篇) http://blog.csdn.net/yanbober/article/details/45912661 Android触摸屏事件派发机制详解与源码分析三(Activi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lGwWNM.html" rel="bookmark">SpringMVC视图机制详解&lbrack;附带源码分析&rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				目录 前言 重要接口和类介绍 源码分析 编码自定义的ViewResolver 总结 参考资料 前言 SpringMVC是目前主流的Web MVC框架之一. 如果有同学对它不熟悉,那么请参考它的入门blog:http://www.cnblogs.com/fangjian0423/p/springMVC-introduction.html 本文将分析SpringMVC的视图这部分内容,让读者了解SpringMVC视图的设计原理. 重要接口和类介绍 1. View接口 视图基础接口,它的各种实现类是无			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38LeDy3.html" rel="bookmark">Shiro的Filter机制详解---源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Shiro的Filter机制详解 首先从spring-shiro.xml的filter配置说起,先回答两个问题: 1, 为什么相同url规则,后面定义的会覆盖前面定义的(执行的时候只执行最后一个). 2, 为什么两个url规则都可以匹配同一个url,只执行第一个呢. 下面分别从这两个问题入手,最终阅读源码得到解答. 问题一解答 相同url但定义在不同的行,后面覆盖前面 如 /usr/login.do=test3 /usr/login.do=test1,test2 不会执行test3的filter			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyKaGn3.html" rel="bookmark">Android ViewGroup触摸屏事件派发机制详解与源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PS一句:最终还是选择CSDN来整理发表这几年的知识点,该文章平行迁移到CSDN.因为CSDN也支持MarkDown语法了,牛逼啊! [工匠若水 http://blog.csdn.net/yanbober] 该篇承接上一篇&lt;Android View触摸屏事件派发机制详解与源码分析&gt;,阅读本篇之前建议先阅读. 1 背景 还记得前一篇&lt;Android View触摸屏事件派发机制详解与源码分析&gt;中关于透过源码继续进阶实例验证模块中存在的点击Button却触发了LinearLayout的事			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/kMLQRB0.html" rel="bookmark" class="title">夺金农场游戏开发 夺金农场系统哪里开发好</a>
					<div>
						夺金农场模式开发,夺金农场系统开发,夺金农场平台开发??找黄经理 185-2946-0381 夺金农场系统开发渠道 夺金农场系统搭建开发 一个企业的创新能力体现在很多方面,包括产品的创新.服务的创新, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/j357WVM.html" rel="bookmark" class="title">ural 2017 Best of a bad lot</a>
					<div>
						2017. Best of a bad lot Time limit: 1.0 secondMemory limit: 64 MB A cruise liner hasn’t moved away f ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/VMGJeG4.html" rel="bookmark" class="title">第一百四十节，JavaScript，封装库--浏览器检测</a>
					<div>
						JavaScript,封装库--浏览器检测 在函数库编写一个,浏览器检测对象 /** sys浏览器检测对象,对象下有两个属性,liu_lan_qi属性和xi_tong属性 * liu_lan_qi属性 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/L3rYXa0.html" rel="bookmark" class="title">CSS3学习总结3-3D与动画</a>
					<div>
						前言:这是篇CSS3中关于3D效果与动画相关的内容. (1)在CSS3的3D效果中,需要结合透视perspective的属性才能看到3d的效果,这个属性在屏幕上实现了元素近大远小的效果,所以要使用CS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eADEa0.html" rel="bookmark" class="title">【源代码】将一个整数的每位数分解并按逆序放入一个数组中（用递归算法）&lpar;C语言实现&rpar;</a>
					<div>
						帮朋友做的,好像是一个面试题.假设不过考察递归的话.应该是够了,程序的健壮性和通用性都非常一般的说-- #include &lt;stdio.h&gt; #include &lt;stdlib.h&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r22Nw3.html" rel="bookmark" class="title">Centos 7安装与配置nagios监控（一）</a>
					<div>
						目  录 序言(必备知识) 一.安装规划 1.1系统环境 1.2所需软件包 二.配置安装环境 2.1同步时间 2.2禁用SElinux 2.3 xftp上传软件包 2.4安装邮件服务 三.监控主机安装 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49bDWbM.html" rel="bookmark" class="title">经典线程同步 关键段CS</a>
					<div>
						上一篇&lt;秒杀多线程第四篇 一个经典的多线程同步问题&gt;提出了一个经典的多线程同步互斥问题,本篇将用关键段CRITICAL_SECTION来尝试解决这个问题. 本文首先介绍下如何使用关键段,然 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KyWOK4.html" rel="bookmark" class="title">所谓线程安全和非线程安全</a>
					<div>
						ArrayList和Vector有什么区别?HashMap和HashTable有什么区别?StringBuilder和StringBuffer有什么区别?这些都是Java面试中常见的基础问题.面对这样 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JkKQ9M.html" rel="bookmark" class="title">HDU 4314 Save the dwarfs &lpar;DP&rpar; ---转载</a>
					<div>
						题目:传送门. 这个是DP,比赛的时候用贪心写了好久没写出来. 题意: 有n个矮人被困在深度为h的井中,每个矮人都ai(脚到肩膀的高度)和bi(手臂长度), 当存在a1 + a2 + ... + ak ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lroXX4.html" rel="bookmark" class="title">大型开源日志系统比较</a>
					<div>
						1. 背景介绍 许多公司的平台每天会产生大量的日志(一般为流式数据,如,搜索引擎的pv,查询等),处理这些日志需要特定的日志系统,一般而言,这些系统需要具有以下特征: (1) 构建应用系统和分析系统的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mg5WxR3.html" rel="bookmark" class="title">spring实战六之使用基于java配置的Spring</a>
					<div>
						之前接触的都是基于XML配置的Spring,Spring3.0开始可以几乎不使用XML而使用纯粹的java代码来配置Spring应用.使用基于java配置的Spring的步骤如下: 1. 创建基于ja ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz5rwO4.html" rel="bookmark" class="title">应用kafka的总结</a>
					<div>
						consumer offset commit 使用kafka的python api时遇到了offset回滚的问题,因为最初使用了autocommit参数,发现有时会重复取记录,发现autocommit ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVYxwQ4.html" rel="bookmark" class="title">Hadoop的体系结构</a>
					<div>
						HDFS和MapReduce是Hadoop的两大核心.而整个Hadoop的体系结构主要是通过HDFS来实现对分布式存储的底层支持的,并且它会通过MapReduce来实现对分布式并行任务处理的程序支持. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/498L6J3.html" rel="bookmark" class="title">Linux&mdash;&mdash;&period;bash&lowbar;profile和&period;bashrc的区别&lpar;如何设置生效&rpar;</a>
					<div>
						/etc/profile:此文件为系统的每个用户设置环境信息,当用户第一次登录时,该文件被执行.并从/etc/profile.d目录的配置文件中搜集shell的设置./etc/bashrc:为每一个运 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AZ1PaM.html" rel="bookmark" class="title">android 页面停几秒后跳转</a>
					<div>
						&lt;span style=&quot;white-space:pre&quot;&gt;      &lt;/span&gt;//实现等待几秒后跳转,方法一 new Handler().postD ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KOy1w0.html" rel="bookmark" class="title">进程和线程关系及区别</a>
					<div>
						一.定义 进程是具有一定独立功能的程序关于某个数据集合上的一次运行活动,进程是系统进行资源分配和调度的一个独立单位. 线程是进程的一个实体,是CPU调度和分派的基本单位,它是比进程更小的能独立运行的基 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyWqeY3.html" rel="bookmark" class="title">&lbrack;hackerrank&rsqb; booking&period;com</a>
					<div>
						I feel really difficult in the questions, while someone could complete it within 5 hours, so far I h ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kpJnp3.html" rel="bookmark" class="title">&lpar;UML总结二&rpar;九种图</a>
					<div>
						上次总结到了UML中的关系,明白了关系,下面让我们总结一下UML中的九种图.图往往比文字要直观,所以我们在开发软件的时候,文档中必不可少要有图,所以这九种图是我们必须要掌握的. 下面我将这九种图分了一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGpWEy0.html" rel="bookmark" class="title">openoffice osl模块学习1</a>
					<div>
						由&quot; can i get a char* , please?&quot;看起: Just barely. OO.o has at least six string wrappers, alt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NjmNJ4.html" rel="bookmark" class="title">检测 NSObject 对象持有的强指针</a>
					<div>
						在上一篇文章中介绍了 FBRetainCycleDetector 的基本工作原理,这一篇文章中我们开始分析它是如何从每一个对象中获得它持有的强指针的. 如果没有看第一篇文章这里还是最好看一下,了解一下 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.022 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
